//+------------------------------------------------------------------+
//|                                              Phy__RubberBand.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1 Gray
#property indicator_color2 PowderBlue
#property indicator_color3 Pink


//---- input parameters
extern int       Periods=13;

extern bool      PlotMomentum = true;
extern bool      PlotMomentumLows = true;
extern bool      PlotMomentumHighs = true;


//---- buffers
double momentumClose[];
double momentumHi[];
double momentumLo[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,0,3);
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexStyle(2,DRAW_LINE,0,2);

   SetIndexBuffer(0,momentumClose);
   SetIndexBuffer(1,momentumHi);
   SetIndexBuffer(2,momentumLo);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();

	int i;
	
	for (i = 1000 ; i >=0; i--){
	
	   //SetIndexStyle(0,DRAW_HISTOGRAM, 0, 3);
   	//SetIndexStyle(1,DRAW_LINE, 0, 1);
   	//SetIndexStyle(2,DRAW_LINE, 0, 1);

	
		//momentumClose[i] =  iMomentum( NULL, 0, Periods, PRICE_CLOSE, i); 
		//momentumHi[i] =     iMomentum( NULL, 0, Periods, PRICE_HIGH, i); 
		//momentumLo[i] =     iMomentum( NULL, 0, Periods, PRICE_LOW, i); 

		// Using calculation in PDF
		
		if(PlotMomentum == true) momentumClose[i] =    Close[i] - Close[i+Periods]; 
		if(PlotMomentumHighs == true) momentumHi[i] =  High[i] - High[i+Periods];  
		if(PlotMomentumLows == true) momentumLo[i] =   Low[i] - Low[i+Periods];  
		
		IndicatorShortName("RubberBand ");

	}

   return(0);
  }
//+------------------------------------------------------------------+